Awkward Array: Complex128Builder Class Reference

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
Complex128Builder Class Reference

Builder node that accumulates real numbers (`double`). More...

`#include <Complex128Builder.h>`

Inheritance diagram for Complex128Builder:

## Public Member Functions
| Complex128Builder (const BuilderOptions &options, GrowableBuffer< std::complex< double > > buffer)
| Create a Complex128Builder from a full set of parameters.
const std::string | classname () const override
| User-friendly name of this class: `"Complex128Builder"`.
const std::string | to_buffers (BuffersContainer &container, int64_t &form_key_id) const override
| Copy the current snapshot into the BuffersContainer and return a Form as a std::string (JSON).
int64_t | length () const override
| Current length of the accumulated array.
void | clear () override
| Removes all accumulated data without resetting the type knowledge.
bool | active () const override
| If `true`, this node has started but has not finished a multi-step command (e.g. `beginX ... endX`).
const BuilderPtr | null () override
| Adds a `null` value to the accumulated data.
const BuilderPtr | boolean (bool x) override
| Adds a boolean value `x` to the accumulated data.
const BuilderPtr | integer (int64_t x) override
| Adds an integer value `x` to the accumulated data.
const BuilderPtr | real (double x) override
| Adds a real value `x` to the accumulated data.
const BuilderPtr | complex (std::complex< double > x) override
| Adds a complex value `x` to the accumulated data.
const BuilderPtr | datetime (int64_t x, const std::string &unit) override
| Adds a datetime value `x` to the accumulated data.
const BuilderPtr | timedelta (int64_t x, const std::string &unit) override
| Adds a timedelta value `x` to the accumulated data.
const BuilderPtr | string (const char *x, int64_t length, const char *encoding) override
| Adds a string value `x` with a given `length` and `encoding` to the accumulated data.
const BuilderPtr | beginlist () override
| Begins building a nested list.
const BuilderPtr | endlist () override
| Ends a nested list.
const BuilderPtr | begintuple (int64_t numfields) override
| Begins building a tuple with a fixed number of fields.
const BuilderPtr | index (int64_t index) override
| Sets the pointer to a given tuple field index; the next command will fill that slot.
const BuilderPtr | endtuple () override
| Ends a tuple.
const BuilderPtr | beginrecord (const char *name, bool check) override
| Begins building a record with an optional name.
void | field (const char *key, bool check) override
| Sets the pointer to a given record field `key`; the next command will fill that slot.
const BuilderPtr | endrecord () override
| Ends a record.
const BuilderOptions & | options () const
const GrowableBuffer< std::complex< double > > & | buffer () const
Public Member Functions inherited from Builder
virtual | ~Builder ()
| Virtual destructor acts as a first non-inline virtual function that determines a specific translation unit in which vtable shall be emitted.
virtual const std::string | classname () const =0
| User-friendly name of this class.
virtual const std::string | to_buffers (BuffersContainer &container, int64_t &form_key_id) const =0
| Copy the current snapshot into the BuffersContainer and return a Form as a std::string (JSON).
virtual int64_t | length () const =0
| Current length of the accumulated array.
virtual void | clear ()=0
| Removes all accumulated data without resetting the type knowledge.
virtual bool | active () const =0
| If `true`, this node has started but has not finished a multi-step command (e.g. `beginX ... endX`).
virtual const BuilderPtr | null ()=0
| Adds a `null` value to the accumulated data.
virtual const BuilderPtr | boolean (bool x)=0
| Adds a boolean value `x` to the accumulated data.
virtual const BuilderPtr | integer (int64_t x)=0
| Adds an integer value `x` to the accumulated data.
virtual const BuilderPtr | real (double x)=0
| Adds a real value `x` to the accumulated data.
virtual const BuilderPtr | complex (std::complex< double > x)=0
| Adds a complex value `x` to the accumulated data.
virtual const BuilderPtr | datetime (int64_t x, const std::string &unit)=0
| Adds a datetime value `x` to the accumulated data.
virtual const BuilderPtr | timedelta (int64_t x, const std::string &unit)=0
| Adds a timedelta value `x` to the accumulated data.
virtual const BuilderPtr | string (const char *x, int64_t length, const char *encoding)=0
| Adds a string value `x` with a given `length` and `encoding` to the accumulated data.
virtual const BuilderPtr | beginlist ()=0
| Begins building a nested list.
virtual const BuilderPtr | endlist ()=0
| Ends a nested list.
virtual const BuilderPtr | begintuple (int64_t numfields)=0
| Begins building a tuple with a fixed number of fields.
virtual const BuilderPtr | index (int64_t index)=0
| Sets the pointer to a given tuple field index; the next command will fill that slot.
virtual const BuilderPtr | endtuple ()=0
| Ends a tuple.
virtual const BuilderPtr | beginrecord (const char *name, bool check)=0
| Begins building a record with an optional name.
virtual void | field (const char *key, bool check)=0
| Sets the pointer to a given record field `key`; the next command will fill that slot.
virtual const BuilderPtr | endrecord ()=0
| Ends a record.

## Static Public Member Functions
static const BuilderPtr | fromempty (const BuilderOptions &options)
| Create an empty Complex128Builder.
static const BuilderPtr | fromint64 (const BuilderOptions &options, const GrowableBuffer< int64_t > &old)
| Create a Complex128Builder from an existing Int64Builder.
static const BuilderPtr | fromfloat64 (const BuilderOptions &options, const GrowableBuffer< double > &old)
| Create a Complex128Builder from an existing Float64Builder.

## Detailed Description

Builder node that accumulates real numbers (`double`).

## Constructor & Destructor Documentation

## ◆ Complex128Builder()

Complex128Builder | ( | const BuilderOptions & | options,
|  | GrowableBuffer< std::complex< double > > | buffer
| ) |  |

Create a Complex128Builder from a full set of parameters.

Parameters

  options | Configuration options for building an array; these are passed to every Builder's constructor.
  buffer | Contains the accumulated real numbers.

## Member Function Documentation

## ◆ active()

bool active | ( |  | ) | const
| overridevirtual

If `true`, this node has started but has not finished a multi-step command (e.g. `beginX ... endX`).

A Complex128Builder is never active.

Implements Builder.

## ◆ beginlist()

const BuilderPtr beginlist | ( |  | ) |
| overridevirtual

Begins building a nested list.

Implements Builder.

## ◆ beginrecord()

const BuilderPtr beginrecord | ( | const char * | name,
|  | bool | check
| ) |  |
| overridevirtual

Begins building a record with an optional name.

Parameters

  name | If specified, this name is used to distinguish records of different types in heterogeneous data (to build a union of record arrays, rather than a record array with union fields and optional values) and it also sets the `"__record__"` parameter to later add custom behaviors in Python.
  check | If `true`, actually do a string comparison to see if the provided `name` matches the previous `name`; if `false`, assume that the same pointer means the same string (safe for string literals).

Implements Builder.

## ◆ begintuple()

const BuilderPtr begintuple | ( | int64_t | numfields | ) |
| overridevirtual

Begins building a tuple with a fixed number of fields.

Implements Builder.

## ◆ boolean()

const BuilderPtr boolean | ( | bool | x | ) |
| overridevirtual

Adds a boolean value `x` to the accumulated data.

Implements Builder.

## ◆ buffer()

const GrowableBuffer< std::complex< double > > & buffer | ( |  | ) | const
| inline

## ◆ classname()

const std::string classname | ( |  | ) | const
| overridevirtual

User-friendly name of this class: `"Complex128Builder"`.

Implements Builder.

## ◆ clear()

void clear | ( |  | ) |
| overridevirtual

Removes all accumulated data without resetting the type knowledge.

Implements Builder.

## ◆ complex()

const BuilderPtr complex | ( | std::complex< double > | x | ) |
| overridevirtual

Adds a complex value `x` to the accumulated data.

Implements Builder.

## ◆ datetime()

const BuilderPtr datetime | ( | int64_t | x,
|  | const std::string & | unit
| ) |  |
| overridevirtual

Adds a datetime value `x` to the accumulated data.

Implements Builder.

## ◆ endlist()

const BuilderPtr endlist | ( |  | ) |
| overridevirtual

Ends a nested list.

Implements Builder.

## ◆ endrecord()

const BuilderPtr endrecord | ( |  | ) |
| overridevirtual

Ends a record.

Implements Builder.

## ◆ endtuple()

const BuilderPtr endtuple | ( |  | ) |
| overridevirtual

Ends a tuple.

Implements Builder.

## ◆ field()

void field | ( | const char * | key,
|  | bool | check
| ) |  |
| overridevirtual

Sets the pointer to a given record field `key`; the next command will fill that slot.

Parameters

  key | Indicates the field to fill.
  check | If `true`, actually do a string comparison to see if `key` matches the previous `key`; if `false`, assume that the same pointer means the same string (safe for string literals).

Record keys are checked in round-robin order. The best performance will be achieved by filling them in the same order for each record. Lookup time for random order scales with the number of fields.

Implements Builder.

## ◆ fromempty()

static const BuilderPtr fromempty | ( | const BuilderOptions & | options | ) |
| static

Create an empty Complex128Builder.

Parameters

  options | Configuration options for building an array; these are passed to every Builder's constructor.

## ◆ fromfloat64()

static const BuilderPtr fromfloat64 | ( | const BuilderOptions & | options,
|  | const GrowableBuffer< double > & | old
| ) |  |
| static

Create a Complex128Builder from an existing Float64Builder.

Parameters

  options | Configuration options for building an array; these are passed to every Builder's constructor.
  old | The Float64Builder's buffer.

## ◆ fromint64()

static const BuilderPtr fromint64 | ( | const BuilderOptions & | options,
|  | const GrowableBuffer< int64_t > & | old
| ) |  |
| static

Create a Complex128Builder from an existing Int64Builder.

Parameters

  options | Configuration options for building an array; these are passed to every Builder's constructor.
  old | The Int64Builder's buffer.

## ◆ index()

const BuilderPtr index | ( | int64_t | index | ) |
| overridevirtual

Sets the pointer to a given tuple field index; the next command will fill that slot.

Implements Builder.

## ◆ integer()

const BuilderPtr integer | ( | int64_t | x | ) |
| overridevirtual

Adds an integer value `x` to the accumulated data.

Implements Builder.

## ◆ length()

int64_t length | ( |  | ) | const
| overridevirtual

Current length of the accumulated array.

Implements Builder.

## ◆ null()

const BuilderPtr null | ( |  | ) |
| overridevirtual

Adds a `null` value to the accumulated data.

Implements Builder.

## ◆ options()

const BuilderOptions & options | ( |  | ) | const
| inline

## ◆ real()

const BuilderPtr real | ( | double | x | ) |
| overridevirtual

Adds a real value `x` to the accumulated data.

Implements Builder.

## ◆ string()

const BuilderPtr string | ( | const char * | x,
|  | int64_t | length,
|  | const char * | encoding
| ) |  |
| overridevirtual

Adds a string value `x` with a given `length` and `encoding` to the accumulated data.

Note
  Currently, only `encoding =`

- `nullptr` (no encoding; a bytestring)
- `"utf-8"` (variable-length Unicode 8-bit encoding)

are supported.

Implements Builder.

## ◆ timedelta()

const BuilderPtr timedelta | ( | int64_t | x,
|  | const std::string & | unit
| ) |  |
| overridevirtual

Adds a timedelta value `x` to the accumulated data.

Implements Builder.

## ◆ to_buffers()

const std::string to_buffers | ( | BuffersContainer & | container,
|  | int64_t & | form_key_id
| ) |  | const
| overridevirtual

Copy the current snapshot into the BuffersContainer and return a Form as a std::string (JSON).

Implements Builder.

The documentation for this class was generated from the following file:

- include/awkward/builder/Complex128Builder.h